From c270d905f5c104fa40fd35d13d7fe169a7ef4624 Mon Sep 17 00:00:00 2001
From: Daniel Mierswa <impulze@impulze.org>
Date: Thu, 28 Jan 2010 08:09:05 +0100
Subject: [PATCH 02/10] Provide abstraction for string options to configure.

Because we now only take --with-* for string passing:
--with-a52-fixed became --enable-a52-fixed
--with-contrib became --enable-contrib
a52-fixed had a bug where with --without-a52-fixed would result in a
false positive.
--without-foo is still possible (as it just sets the argument to "no")
but it will print a notice during configure, saying that it's either a
really uncommon string to pass to configure, or that the user made a
mistake by thinking --without-foo disables something.

Also remove the special mozilla_sdk_xpcom handling for mingw, it was
removed in 11390074753cc36741787113e7ee11324315f4ac.

Signed-off-by: Daniel Mierswa <impulze@impulze.org>
---
 configure.ac       |  509 +++++++++++++++++++++++-----------------------------
 m4/vlc_features.m4 |   95 ++++++++++-
 2 files changed, 316 insertions(+), 288 deletions(-)

diff --git a/configure.ac b/configure.ac
index bc6ed1c..94753d0 100644
--- a/configure.ac
+++ b/configure.ac
@@ -88,11 +88,9 @@ AC_DEFUN([EXTEND_HELP_STRING],
 
 dnl Allow binary package maintainer to pass a custom string to avoid
 dnl cache problem
-AC_ARG_WITH(binary-version,
-	AS_HELP_STRING([--with-binary-version=STRING],
-	     [To avoid plugins cache problem between binary version]),[],[])
-AS_IF([test -n "${with_binary_version}"],[
-      AC_DEFINE_UNQUOTED([DISTRO_VERSION],["${with_binary_version}"],
+VLC_STRING_OPTION([binary-version], [To avoid plugins cache problem between binary version], [STRING])
+AS_IF([VLC_STRING_SET([binary-version])], [
+      AC_DEFINE_UNQUOTED([DISTRO_VERSION],["${vlc_string_binary_version}"],
 			 [Binary specific version])
       ])
 
@@ -100,9 +98,8 @@ AS_IF([test -n "${with_binary_version}"],[
 dnl
 dnl  Check for the contrib directory
 dnl
-AC_ARG_WITH(contrib,
-    [  --without-contrib       do not use the libraries in CONTRIB_DIR],[],[])
-  AS_IF([test "${with_contrib}" != "no"],[
+VLC_FEATURE_OPTION([contrib], [use the libraries in CONTRIB_DIR], [enabled])
+AS_IF([VLC_FEATURE_ENABLED([contrib])], [
     AC_ARG_VAR([CONTRIB_DIR], [directory containing pre-built contrib, overriding extras/contrib])
     if test -z "$CONTRIB_DIR"
     then
@@ -138,12 +135,7 @@ AC_ARG_WITH(contrib,
     LDFLAGS="${LDFLAGS} -L${CONTRIB_DIR}/lib"
     LDFLAGS_save="${LDFLAGS_save} -L${CONTRIB_DIR}/lib"
 
-    if test -z $with_mozilla_sdk_path; then
-       with_mozilla_sdk_path=${CONTRIB_DIR}/gecko-sdk
-    fi
-    if test -z $with_cyberlink_tree; then
-       with_cyberlink_tree=${CONTRIB_DIR}/src/clinkcc
-    fi
+    have_contrib_libs="yes"
 
     if test "${SYS}" = "darwin"; then
       export LD_LIBRARY_PATH=${CONTRIB_DIR}/lib:$LD_LIBRARY_PATH
@@ -210,10 +202,8 @@ case "${host_os}" in
     AS_IF([VLC_FEATURE_ENABLED([macosx-defaults])], [
         echo ""
         echo "Building with Mac OS X defaults:"
-        with_macosx_version_min="10.5"
-        echo "  Assuming --with-macosx-version-min=10.5"
-        with_macosx_sdk="/Developer/SDKs/MacOSX${with_macosx_version_min}.sdk"
-        echo "  Assuming --with-macosx-sdk=/Developer/SDKs/MacOSX${with_macosx_version_min}.sdk"
+        VLC_STRING_FORCE([macosx-version-min], [10.5])
+        VLC_STRING_FORCE([macosx-sdk], [/Developer/SDKs/MacOSX10.5.sdk])
         build_dir=`pwd`
         echo "  Assuming --prefix=${build_dir}/vlc_install_dir"
         ac_default_prefix="${build_dir}/vlc_install_dir"
@@ -235,29 +225,27 @@ case "${host_os}" in
     dnl
     dnl  Check for Mac OS X SDK settings
     dnl
-    AC_ARG_WITH(macosx-sdk,
-       [  --with-macosx-sdk=DIR   compile using the SDK in DIR])
-    if test "${with_macosx_sdk}" != "" ; then
-        CPP="${CPP} -isysroot ${with_macosx_sdk}"
-        CC="${CC} -isysroot ${with_macosx_sdk}"
-        CXX="${CXX} -isysroot ${with_macosx_sdk}"
-        OBJC="${OBJC} -isysroot ${with_macosx_sdk}"
-        LD="${LD} -syslibroot ${with_macosx_sdk}"
-    fi
-    AC_ARG_WITH(macosx-version-min,
-       [  --with-macosx-version-min=VERSION compile for MacOSX VERSION and above])
-    if test "${with_macosx_version_min}" != "" ; then
-        CPP="${CPP} -mmacosx-version-min=${with_macosx_version_min}"
-        CC="${CC} -mmacosx-version-min=${with_macosx_version_min}"
-        CXX="${CXX} -mmacosx-version-min=${with_macosx_version_min}"
-        OBJC="${OBJC} -mmacosx-version-min=${with_macosx_version_min}"
-        LD="${LD} -macosx_version_min=${with_macosx_version_min}"
-        CFLAGS_save="${CFLAGS_save} -DMACOSX_DEPLOYMENT_TARGET=${with_macosx_version_min}"; CFLAGS="${CFLAGS_save}"
-        CXXFLAGS_save="${CXXFLAGS_save} -DMACOSX_DEPLOYMENT_TARGET=${with_macosx_version_min}"; CXXFLAGS="${CXXFLAGS_save}"
-        OBJCFLAGS_save="${OBJCFLAGS_save} -DMACOSX_DEPLOYMENT_TARGET=${with_macosx_version_min}"; OBJCFLAGS="${OBJCFLAGS_save}"
-        MACOSX_DEPLOYMENT_TARGET=${with_macosx_version_min}
+    VLC_STRING_OPTION([macosx-sdk], [compile using the SDK in DIR], [DIR])
+    AS_IF([VLC_STRING_SET([macosx-sdk])], [
+        CPP="${CPP} -isysroot ${vlc_string_macosx_sdk}"
+        CC="${CC} -isysroot ${vlc_string_macosx_sdk}"
+        CXX="${CXX} -isysroot ${vlc_string_macosx_sdk}"
+        OBJC="${OBJC} -isysroot ${vlc_string_macosx_sdk}"
+        LD="${LD} -syslibroot ${vlc_string_macosx_sdk}"
+    ])
+    VLC_STRING_OPTION([macosx-version-min], [compile for MacOSX VERSION and above], [VERSION])
+    AS_IF([VLC_STRING_SET([macosx-sdk])], [
+        CPP="${CPP} -mmacosx-version-min=${vlc_string_macosx_version_min}"
+        CC="${CC} -mmacosx-version-min=${vlc_string_macosx_version_min}"
+        CXX="${CXX} -mmacosx-version-min=${vlc_string_macosx_version_min}"
+        OBJC="${OBJC} -mmacosx-version-min=${vlc_string_macosx_version_min}"
+        LD="${LD} -macosx_version_min=${vlc_string_macosx_version_min}"
+        CFLAGS_save="${CFLAGS_save} -DMACOSX_DEPLOYMENT_TARGET=${vlc_string_macosx_version_min}"; CFLAGS="${CFLAGS_save}"
+        CXXFLAGS_save="${CXXFLAGS_save} -DMACOSX_DEPLOYMENT_TARGET=${vlc_string_macosx_version_min}"; CXXFLAGS="${CXXFLAGS_save}"
+        OBJCFLAGS_save="${OBJCFLAGS_save} -DMACOSX_DEPLOYMENT_TARGET=${vlc_string_macosx_version_min}"; OBJCFLAGS="${OBJCFLAGS_save}"
+        MACOSX_DEPLOYMENT_TARGET=${vlc_string_macosx_version_min}
         export MACOSX_DEPLOYMENT_TARGET
-    fi
+    ])
     ;;
   darwin9*)
     if test "${host_cpu}" = "i386"; then
@@ -1474,14 +1462,12 @@ AM_CONDITIONAL([HAVE_ALTIVEC], [test "$have_altivec" = "yes"])
 dnl
 dnl  Special arch tuning
 dnl
-AC_ARG_WITH(tuning,
-[  --with-tuning=ARCH      enable special tuning for an architecture
-                          (default Pentium 2 on IA-32 and G4 on PPC)])
-if test -n "${with_tuning}"; then
-    if test "${with_tuning}" != "no"; then
-        CFLAGS_TUNING="-mtune=${with_tuning}"
-    fi
-else
+VLC_STRING_OPTION([tuning], [enable special tuning for an architecture], [ARCH], [
+  Pentium 2 on IA-32 and G4 on PPC
+])
+AS_IF([VLC_STRING_SET([tuning])], [
+    CFLAGS_TUNING="-mtune=${vlc_string_tuning}"
+], [
     if test "${SYS}" = "darwin" -a "${host_cpu}" != "powerpc"; then
         CFLAGS_TUNING="-march=prescott -mtune=generic"
     elif test "${host_cpu}" = "i686" -o "${host_cpu}" = "i586" -o "${host_cpu}" = "i486" -o "${host_cpu}" = "i386"; then
@@ -1491,7 +1477,7 @@ else
     elif test "${host_cpu}" = "powerpc"; then
         CFLAGS_TUNING="-mtune=G4";
     fi
-fi
+])
 
 dnl NOTE: this can't be cached cleanly
 AS_IF([test "${CFLAGS_TUNING}"],
@@ -1502,7 +1488,7 @@ AS_IF([test "${CFLAGS_TUNING}"],
     AC_COMPILE_IFELSE([ ],
                       [tuning="yes"],
                       [CFLAGS_TUNING=""; tuning="no"
-                       AS_IF([test "${with_tuning}"],
+                       AS_IF([VLC_STRING_SET([with-tuning])],
                              [AC_MSG_ERROR([requested tuning not supported])])])
 
     AC_MSG_RESULT([$tuning])
@@ -1716,13 +1702,12 @@ dnl  live555 input
 dnl
 VLC_FEATURE_OPTION([live555], [live555 RTSP input plugin])
 AS_IF([VLC_FEATURE_ENABLED([live555])], [
-  AC_ARG_WITH(live555-tree,
-    [  --with-live555-tree=PATH live.com tree for static linking])
+  VLC_STRING_OPTION([live555-tree], [live.com tree for static linking], [PATH])
 
   dnl
   dnl test for --with-live555-tree
   dnl
-  if test -z "${with_live555_tree}" -a "${CXX}" != ""; then
+  AS_IF([{ VLC_STRING_UNSET([live555-tree]) && test "${CXX}" != "" ;}], [
     AC_LANG_PUSH(C++)
     CPPFLAGS_save="${CPPFLAGS}"
     CPPFLAGS_live555="-I/usr/include/liveMedia -I/usr/include/groupsock -I/usr/include/BasicUsageEnvironment -I/usr/include/UsageEnvironment"
@@ -1774,12 +1759,12 @@ lternatively you can use --disable-live555 to disable the liveMedia plugin.])
     CPPFLAGS="${CPPFLAGS_save}"
     AC_LANG_POP(C++)
   else
-    AC_MSG_CHECKING(for liveMedia/libliveMedia.a in ${with_live555_tree})
-    real_live555_tree="`cd ${with_live555_tree} 2>/dev/null && pwd`"
+    AC_MSG_CHECKING(for liveMedia/libliveMedia.a in ${vlc_string_live555_tree})
+    real_live555_tree="`cd ${vlc_string_live555_tree} 2>/dev/null && pwd`"
     if test -z "${real_live555_tree}"; then
       dnl  The given directory can't be found
       AC_MSG_RESULT(no)
-      AC_MSG_ERROR([cannot cd to ${with_live555_tree}])
+      AC_MSG_ERROR([cannot cd to ${vlc_string_live555_tree}])
     fi
     if test -f "${real_live555_tree}/liveMedia/libliveMedia.a"; then
       AC_MSG_RESULT(${real_live555_tree}/liveMedia/libliveMedia.a)
@@ -1824,10 +1809,10 @@ lternatively you can use --disable-live555 to disable the liveMedia plugin.])
       dnl  The given live555 wasn't built
         AC_MSG_RESULT(no)
       AS_IF([VLC_FEATURE_REQUESTED([live555])], [
-        AC_MSG_ERROR([cannot find ${real_live555_tree}/liveMedia/libliveMedia.a, make sure you compiled live555 in ${with_live555_tree}])
+        AC_MSG_ERROR([cannot find ${real_live555_tree}/liveMedia/libliveMedia.a, make sure you compiled live555 in ${vlc_string_live555_tree}])
       ])
     fi
-  fi
+  ])
 ])
 
 dnl
@@ -1842,20 +1827,16 @@ dnl dvdread module: check for libdvdread
 dnl
 VLC_FEATURE_OPTION([dvdread], [dvdread input module])
 AS_IF([VLC_FEATURE_ENABLED([dvdread])], [
-  AC_ARG_WITH(dvdread,
-  [  --with-dvdread=PATH     libdvdread headers and libraries])
-  AC_ARG_WITH(dvdread-tree,
-  [  --with-dvdread-tree=PATH libdvdread tree for static linking])
+  VLC_STRING_OPTION([dvdread], [libdvdread headers and libraries], [PATH])
+  VLC_STRING_OPTION([dvdread-tree], [libdvdread tree for static linking], [PATH])
 
   dnl Temporary hack (yeah, sure ;)
   if test "${SYS}" = "mingw32" || test "${SYS}" = "darwin" || test "${SYS}" = "beos" ; then
       VLC_ADD_LIBS([dvdread],[-ldvdcss])
   fi
 
-  if test -z "${with_dvdread}"
-  then
-    if test -z "${with_dvdread_tree}"
-    then
+  AS_IF([VLC_STRING_UNSET([dvdread])], [
+    AS_IF([VLC_STRING_UNSET([dvdread-tree])], [
       AC_CHECK_HEADERS(dvdread/dvd_reader.h,
         [ VLC_ADD_PLUGIN([dvdread])
           VLC_ADD_LIBS([dvdread],[-ldvdread ${LIBS_dvdcss}])
@@ -1869,14 +1850,14 @@ AS_IF([VLC_FEATURE_ENABLED([dvdread])], [
 	     ])
 	   ])
 	])
-    else
-      AC_MSG_CHECKING(for libdvdread.a in ${with_dvdread_tree})
-      real_dvdread_tree="`cd ${with_dvdread_tree} 2>/dev/null && pwd`"
+    ], [
+      AC_MSG_CHECKING(for libdvdread.a in ${vlc_string_dvdread_tree})
+      real_dvdread_tree="`cd ${vlc_string_dvdread_tree} 2>/dev/null && pwd`"
       if test -z "${real_dvdread_tree}"
       then
         dnl  The given directory can't be found
         AC_MSG_RESULT(no)
-        AC_MSG_ERROR([cannot cd to ${with_dvdread_tree}])
+        AC_MSG_ERROR([cannot cd to ${vlc_string_dvdread_tree}])
       fi
       if test -f "${real_dvdread_tree}/dvdread/.libs/libdvdread.a"
       then
@@ -1888,24 +1869,24 @@ AS_IF([VLC_FEATURE_ENABLED([dvdread])], [
       else
         dnl  The given libdvdread wasn't built
         AC_MSG_RESULT(no)
-        AC_MSG_ERROR([cannot find ${real_dvdread_tree}/dvdread/.libs/libdvdread.a, make sure you compiled libdvdread in ${with_dvdread_tree}])
+        AC_MSG_ERROR([cannot find ${real_dvdread_tree}/dvdread/.libs/libdvdread.a, make sure you compiled libdvdread in ${vlc_string_dvdread_tree}])
       fi
-    fi
-  else
-    AC_MSG_CHECKING(for dvdread headers in ${with_dvdread})
-    if test -f ${with_dvdread}/include/dvdread/dvd_reader.h
+    ])
+  ], [
+    AC_MSG_CHECKING(for dvdread headers in ${vlc_string_dvdread})
+    if test -f ${vlc_string_dvdread}/include/dvdread/dvd_reader.h
     then
-      dnl  Use ${with_dvdread}/include/dvdread/dvd_reader.h
+      dnl  Use ${vlc_string_dvdread}/include/dvdread/dvd_reader.h
       AC_MSG_RESULT(yes)
       VLC_ADD_PLUGIN([dvdread])
-      VLC_ADD_LIBS([dvdread],[-L${with_dvdread}/lib -ldvdread ${LIBS_dvdcss}])
-      VLC_ADD_CPPFLAGS([dvdread],[-I${with_dvdread}/include])
+      VLC_ADD_LIBS([dvdread],[-L${vlc_string_dvdread}/lib -ldvdread ${LIBS_dvdcss}])
+      VLC_ADD_CPPFLAGS([dvdread],[-I${vlc_string_dvdread}/include])
     else
       dnl  No libdvdread could be found, sorry
       AC_MSG_RESULT(no)
-      AC_MSG_ERROR([cannot find ${with_dvdread}/include/dvdread/dvd_reader.h])
+      AC_MSG_ERROR([cannot find ${vlc_string_dvdread}/include/dvdread/dvd_reader.h])
     fi
-  fi
+  ])
 ])
 
 dnl
@@ -1919,13 +1900,11 @@ AS_IF([VLC_FEATURE_ENABLED([dvdnav])], [
   fi
 
   DVDNAV_PATH="${PATH}"
-  AC_ARG_WITH(dvdnav-config-path,
-    [  --with-dvdnav-config-path=PATH dvdnav-config path (default search in \$PATH)],
-    [ if test "${with_dvdnav_config_path}" != "no"
-      then
-        DVDNAV_PATH="${with_dvdnav_config_path}:${PATH}"
-      fi ])
-  AC_PATH_PROG(DVDNAV_CONFIG, dvdnav-config, no, ${DVDNAV_PATH})
+  VLC_STRING_OPTION([dvdnav-config-path], [dvdnav-config path], [PATH], [search in \$PATH])
+  AS_IF([VLC_STRING_SET([dvdnav-config-path])], [
+    DVDNAV_PATH="${vlc_string_dvdnav_config_path}:${PATH}"
+  ])
+  AC_PATH_PROG(DVDNAV_CONFIG, dvdnav-config, no, [${DVDNAV_PATH}])
   if test "${DVDNAV_CONFIG}" != "no"
   then
     VLC_ADD_PLUGIN([dvdnav])
@@ -1967,28 +1946,29 @@ dnl  OpenCV wrapper and example filters
 dnl
 VLC_FEATURE_OPTION([opencv], [OpenCV (computer vision) filter], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([opencv]) && test "${CXX}" != ""], [
-  AC_ARG_WITH(opencv-tree,
-  [  --with-opencv-tree=PATH opencv tree for linking])
+  VLC_STRING_OPTION([opencv-tree], [opencv tree for linking], [PATH])
     if test "${SYS}" = "mingw32"
     then
-      test -z "${with_opencv_tree}" && AC_MSG_ERROR([You have to specify --with-opencv-tree])
-      AC_MSG_CHECKING(for opencv in ${with_opencv_tree})
-      if test -f ${with_opencv_tree}/cv/include/cv.h -a -f ${with_opencv_tree}/cxcore/include/cxcore.h \
-        -a -f ${with_opencv_tree}/cvaux/include/cvaux.h -a -f ${with_opencv_tree}/otherlibs/highgui/highgui.h
+      AS_IF([VLC_STRING_UNSET([opencv-tree])], [
+        AC_MSG_ERROR([You have to specify --with-opencv-tree])
+      ])
+      AC_MSG_CHECKING(for opencv in ${vlc_string_opencv_tree})
+      if test -f ${vlc_string_opencv_tree}/cv/include/cv.h -a -f ${vlc_string_opencv_tree}/cxcore/include/cxcore.h \
+        -a -f ${vlc_string_opencv_tree}/cvaux/include/cvaux.h -a -f ${vlc_string_opencv_tree}/otherlibs/highgui/highgui.h
       then
         AC_MSG_RESULT(yes)
         VLC_ADD_PLUGIN([opencv_wrapper])
-        VLC_ADD_LIBS([opencv_wrapper],[-L${with_opencv_tree}/lib -lcv -lcxcore -lcvaux -lhighgui])
-        VLC_ADD_CFLAGS([opencv_wrapper],[-I${with_opencv_tree}/cv/include -I${with_opencv_tree}/cxcore/include -I${with_opencv_tree}/cvaux/include -I${with_opencv_tree}/otherlibs/highgui])
+        VLC_ADD_LIBS([opencv_wrapper],[-L${vlc_string_opencv_tree}/lib -lcv -lcxcore -lcvaux -lhighgui])
+        VLC_ADD_CFLAGS([opencv_wrapper],[-I${vlc_string_opencv_tree}/cv/include -I${vlc_string_opencv_tree}/cxcore/include -I${vlc_string_opencv_tree}/cvaux/include -I${vlc_string_opencv_tree}/otherlibs/highgui])
         AC_LANG_PUSH(C++)
         VLC_ADD_PLUGIN([opencv_example])
-        VLC_ADD_LIBS([opencv_example],[-L${with_opencv_tree}/lib -lcv -lcxcore -lcvaux -lhighgui])
-        VLC_ADD_CXXFLAGS([opencv_example],[-I${with_opencv_tree}/cv/include -I${with_opencv_tree}/cxcore/include -I${with_opencv_tree}/cvaux/include -I${with_opencv_tree}/otherlibs/highgui])
+        VLC_ADD_LIBS([opencv_example],[-L${vlc_string_opencv_tree}/lib -lcv -lcxcore -lcvaux -lhighgui])
+        VLC_ADD_CXXFLAGS([opencv_example],[-I${vlc_string_opencv_tree}/cv/include -I${vlc_string_opencv_tree}/cxcore/include -I${vlc_string_opencv_tree}/cvaux/include -I${vlc_string_opencv_tree}/otherlibs/highgui])
         AC_LANG_POP(C++)
       else
         dnl  No opencv could be found, sorry
         AC_MSG_RESULT(no)
-        AC_MSG_ERROR([cannot find opencv in ${with_opencv_tree}])
+        AC_MSG_ERROR([cannot find opencv in ${vlc_string_opencv_tree}])
       fi
     else
       PKG_CHECK_MODULES(OPENCV, opencv,
@@ -2035,21 +2015,17 @@ dnl
 VLC_FEATURE_OPTION([dvbpsi], [dvbpsi ts mux and demux module])
 have_dvbpsi=no
 AS_IF([VLC_FEATURE_ENABLED([dvbpsi])], [
-  AC_ARG_WITH(dvbpsi,
-  [  --with-dvbpsi=PATH      libdvbpsi headers and libraries])
-  AC_ARG_WITH(dvbpsi,
-  [  --with-dvbpsi-tree=PATH libdvbpsi tree for static linking])
-  case "${with_dvbpsi}" in
-  ""|yes)
-    if test -z "${with_dvbpsi_tree}"
-    then
+  VLC_STRING_OPTION([dvbpsi], [libdvbpsi headers and libraries], [PATH])
+  VLC_STRING_OPTION([dvbpsi-tree], [libdvbpsi tree for static linking], [PATH])
+  AS_IF([VLC_STRING_UNSET([dvbpsi])], [
+    AS_IF([VLC_STRING_UNSET([dvbpsi-tree])], [
       AC_CHECK_HEADERS(dvbpsi/dr.h,
         [ VLC_ADD_PLUGIN([ts])
           AS_IF([VLC_FEATURE_ENABLED([sout])], [
             VLC_ADD_PLUGIN([mux_ts])
           ])
           VLC_ADD_LIBS([mux_ts ts dvb],[-ldvbpsi])
-	  have_dvbpsi=yes],
+          have_dvbpsi=yes],
         [  AC_MSG_WARN([cannot find libdvbpsi headers]) ],
         [#if defined( HAVE_STDINT_H )
 #   include <stdint.h>
@@ -2060,14 +2036,14 @@ AS_IF([VLC_FEATURE_ENABLED([dvbpsi])], [
 #include <dvbpsi/descriptor.h>
 #include <dvbpsi/pat.h>
 #include <dvbpsi/pmt.h>])
-    else
-      AC_MSG_CHECKING(for libdvbpsi.a in ${with_dvbpsi_tree})
-      real_dvbpsi_tree="`cd ${with_dvbpsi_tree} 2>/dev/null && pwd`"
+    ], [
+      AC_MSG_CHECKING(for libdvbpsi.a in ${vlc_string_dvbpsi_tree})
+      real_dvbpsi_tree="`cd ${vlc_string_dvbpsi_tree} 2>/dev/null && pwd`"
       if test -z "${real_dvbpsi_tree}"
       then
         dnl  The given directory can't be found
         AC_MSG_RESULT(no)
-        AC_MSG_ERROR([cannot cd to ${with_dvbpsi_tree}])
+        AC_MSG_ERROR([cannot cd to ${vlc_string_dvbpsi_tree}])
       fi
       if test -f "${real_dvbpsi_tree}/src/.libs/libdvbpsi.a"
       then
@@ -2079,27 +2055,17 @@ AS_IF([VLC_FEATURE_ENABLED([dvbpsi])], [
         ])
         VLC_ADD_CPPFLAGS([mux_ts ts dvb],[-I${real_dvbpsi_tree}/src])
         VLC_ADD_LIBS([mux_ts ts dvb],[${real_dvbpsi_tree}/src/.libs/libdvbpsi.a])
-	have_dvbpsi=yes
+        have_dvbpsi=yes
       else
         dnl  The given libdvbpsi wasn't built
         AC_MSG_RESULT(no)
-        AC_MSG_ERROR([cannot find ${real_dvbpsi_tree}/src/.libs/libdvbpsi.a, make sure you compiled libdvbpsi in ${with_dvbpsi_tree}])
+        AC_MSG_ERROR([cannot find ${real_dvbpsi_tree}/src/.libs/libdvbpsi.a, make sure you compiled libdvbpsi in ${vlc_string_dvbpsi_tree}])
       fi
-    fi
-  ;;
-  no)
-    dnl  Compile without dvbpsi
-  ;;
-  *)
-    AC_MSG_CHECKING(for dvbpsi headers in ${with_dvbpsi})
-    if test -z "${with_dvbpsi}"
-    then
-      LDFLAGS_test=""
-      CPPFLAGS_test=""
-    else
-      LDFLAGS_test="-L${with_dvbpsi}/lib"
-      CPPFLAGS_test="-I${with_dvbpsi}/include"
-    fi
+    ])
+  ], [
+    AC_MSG_CHECKING(for dvbpsi headers in ${vlc_string_dvbpsi})
+    LDFLAGS_test="-L${vlc_string_dvbpsi}/lib"
+    CPPFLAGS_test="-I${vlc_string_dvbpsi}/include"
     CPPFLAGS="${CPPFLAGS_save} ${CPPFLAGS_test}"
     AC_CHECK_HEADERS([dvbpsi/dr.h],[
       VLC_ADD_PLUGIN([ts])
@@ -2125,8 +2091,7 @@ AS_IF([VLC_FEATURE_ENABLED([dvbpsi])], [
 #include <dvbpsi/pat.h>
 #include <dvbpsi/pmt.h>])
     CPPFLAGS="${CPPFLAGS_save}"
-  ;;
-  esac
+  ])
   AC_CHECK_LIB(dvbpsi, dvbpsi_GenSDTSections, [
     AC_DEFINE(HAVE_DVBPSI_SDT, 1, [Define if you have dvbpsi_GenSDTSections.])
   ], [], [${LIBS_ts}])
@@ -2138,12 +2103,10 @@ dnl  Video4Linux plugin
 dnl
 VLC_FEATURE_OPTION([v4l], [Video4Linux input support], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([v4l])], [
-  AC_ARG_WITH(v4l,
-    [  --with-v4l=PATH         path to a v4l-enabled kernel tree],[],[])
-  if test "${with_v4l}" != "no" -a -n "${with_v4l}"
-  then
-    VLC_ADD_CPPFLAGS([v4l],[-I${with_v4l}/include])
-  fi
+  VLC_STRING_OPTION([v4l], [path to a v4l-enabled kernel tree], [PATH])
+  AS_IF([VLC_STRING_SET([v4l])], [
+    VLC_ADD_CPPFLAGS([v4l],[-I${vlc_string_v4l}/include])
+  ])
 
   CPPFLAGS="${CPPFLAGS_save} ${CPPFLAGS_v4l}"
   AC_CHECK_HEADERS(linux/videodev.h, [
@@ -2170,12 +2133,10 @@ dnl  Video4Linux2 plugin
 dnl
 VLC_FEATURE_OPTION([v4l2], [Video4Linux2 input support])
 AS_IF([VLC_FEATURE_ENABLED([v4l2])], [
-  AC_ARG_WITH(v4l2,
-    [  --with-v4l2=PATH        path to a v4l2-enabled kernel tree],[],[])
-  if test "${with_v4l2}" != "no" -a -n "${with_v4l2}"
-  then
-    VLC_ADD_CPPFLAGS([v4l2],[-I${with_v4l2}/include])
-  fi
+  VLC_STRING_OPTION([v4l2], [path to a v4l2-enabled kernel tree], [PATH])
+  AS_IF([VLC_STRING_SET([v4l2])], [
+    VLC_ADD_CPPFLAGS([v4l2],[-I${vlc_string_v4l2}/include])
+  ])
 
   CPPFLAGS="${CPPFLAGS_save} ${CPPFLAGS_v4l2}"
   AC_CHECK_HEADERS(linux/videodev2.h, [
@@ -2203,12 +2164,12 @@ dnl
 VLC_FEATURE_OPTION([pvr], [PVR cards access module], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([pvr])], [
   VLC_ADD_PLUGIN([pvr])
-  AC_ARG_WITH(videodev2,
-    [  --with-videodev2=FILE   Location of videodev2.h file (default /usr/include/linux/videodev2.h)],[],[])
-  if test "${with_videodev2}" != "no" -a -n "${with_videodev2}"
-  then
-    AC_DEFINE_UNQUOTED(VIDEODEV2_H_FILE, "${with_videodev2}", [Location of videodev2.h])
-  fi
+  VLC_STRING_OPTION([videodev2], [Location of videodev2.h file], [FILE], [
+    /usr/include/linux/videodev2.h
+  ])
+  AS_IF([VLC_STRING_SET([videodev2])], [
+    AC_DEFINE_UNQUOTED(VIDEODEV2_H_FILE, "${vlc_string_videodev2}", [Location of videodev2.h])
+  ])
 
   AC_CACHE_CHECK([for new linux/videodev2.h],
       [ac_cv_new_linux_videodev2_h],
@@ -2311,13 +2272,11 @@ dnl
 VLC_FEATURE_OPTION([dvb], [DVB-S/T/C card support])
 AS_IF([VLC_FEATURE_ENABLED([dvb])], [
     AS_IF([test "${have_dvbpsi}" = "yes" ],[
-    AC_ARG_WITH(dvb,
-     [  --with-dvb=PATH         path to a dvb- and v4l2-enabled kernel tree],[],[])
-     if test "${with_dvb}" != "no" -a -n "${with_dvb}"
-     then
-       VLC_ADD_CFLAGS([dvb],[-I${with_dvb}/include])
-     fi
-     CPPFLAGS="${CPPFLAGS_save} -I${with_dvb}/include"
+    VLC_STRING_OPTION([dvb], [path to a dvb- and v4l2-enabled kernel tree], [PATH])
+     AS_IF([VLC_STRING_SET([dvb])], [
+       VLC_ADD_CFLAGS([dvb],[-I${vlc_string_dvb}/include])
+     ])
+     CPPFLAGS="${CPPFLAGS_save} -I${vlc_string_dvb}/include"
      AC_CHECK_HEADERS(linux/dvb/version.h linux/dvb/frontend.h, [
      VLC_ADD_PLUGIN([dvb])
      ],[AC_MSG_WARN(linux-dvb headers not found, dvb disabled)])
@@ -2438,17 +2397,15 @@ dnl  modplug demux plugin
 dnl
 VLC_FEATURE_OPTION([mod], [Mod demux support])
 AS_IF([VLC_FEATURE_ENABLED([mod])], [
-  AC_ARG_WITH(mod-tree,
-  [  --with-mod-tree=PATH    mod tree for static linking])
-  if test -n "${with_mod_tree}"
-  then
-    AC_MSG_CHECKING(for libmodplug.a in ${with_mod_tree})
-    real_mod_tree="`cd ${with_mod_tree} 2>/dev/null && pwd`"
+  VLC_STRING_OPTION([mod-tree], [mod tree for static linking], [PATH])
+  AS_IF([VLC_STRING_SET([mod-tree])], [
+    AC_MSG_CHECKING(for libmodplug.a in ${vlc_string_mod_tree})
+    real_mod_tree="`cd ${vlc_string_mod_tree} 2>/dev/null && pwd`"
     if test -z "${real_mod_tree}"
     then
       dnl  The given directory can't be found
       AC_MSG_RESULT(no)
-      AC_MSG_ERROR([cannot cd to ${with_mod_tree}])
+      AC_MSG_ERROR([cannot cd to ${vlc_string_mod_tree}])
     fi
     if test -f "${real_mod_tree}/src/.libs/libmodplug.a"
     then
@@ -2460,15 +2417,15 @@ AS_IF([VLC_FEATURE_ENABLED([mod])], [
     else
       dnl  The given mod wasn't built
       AC_MSG_RESULT(no)
-      AC_MSG_ERROR([cannot find ${real_mod_tree}/src/.libs/libmodplug.a, make sure you compiled mod in ${with_mod_tree}])
+      AC_MSG_ERROR([cannot find ${real_mod_tree}/src/.libs/libmodplug.a, make sure you compiled mod in ${vlc_string_mod_tree}])
     fi
-  else
+  ], [
     PKG_CHECK_MODULES(LIBMODPLUG, libmodplug >= 0.8,
         [ VLC_ADD_PLUGIN([mod])
           VLC_ADD_CXXFLAGS([mod],[$LIBMODPLUG_CFLAGS])
           VLC_ADD_LIBS([mod],[$LIBMODPLUG_LIBS])
         ],[AC_MSG_WARN([libmodplug not found!])])
-  fi
+  ])
 ])
 
 dnl
@@ -2490,17 +2447,15 @@ dnl
 VLC_FEATURE_OPTION([gme], [Game Music Emu demux support])
 AS_IF([VLC_FEATURE_ENABLED([gme]) && test "${CXX}" != ""], [
   AC_LANG_PUSH(C++)
-  AC_ARG_WITH(gme-tree,
-  [  --with-gme-tree=PATH    gme tree for static linking])
-  if test -n "${with_gme_tree}"
-  then
-    AC_MSG_CHECKING(for libgme.a in ${with_mod_tree})
-    real_gme_tree="`cd ${with_gme_tree} 2>/dev/null && pwd`"
+  VLC_STRING_OPTION([gme-tree], [gme tree for static linking], [PATH])
+  AS_IF([VLC_STRING_SET([gme-tree])], [
+    AC_MSG_CHECKING(for libgme.a in ${vlc_string_mod_tree})
+    real_gme_tree="`cd ${vlc_string_gme_tree} 2>/dev/null && pwd`"
     if test -z "${real_gme_tree}"
     then
       dnl  The given directory can't be found
       AC_MSG_RESULT(no)
-      AC_MSG_ERROR([cannot cd to ${with_gme_tree}])
+      AC_MSG_ERROR([cannot cd to ${vlc_string_gme_tree}])
     fi
     if test -f "${real_gme_tree}/gme/libgme.a"
     then
@@ -2512,11 +2467,11 @@ AS_IF([VLC_FEATURE_ENABLED([gme]) && test "${CXX}" != ""], [
     else
       dnl  The given gme wasn't built
       AC_MSG_RESULT(no)
-      AC_MSG_ERROR([cannot find ${real_mod_tree}/gme/libgme.a, make sure you compiled gme in ${with_gme_tree}])
+      AC_MSG_ERROR([cannot find ${real_mod_tree}/gme/libgme.a, make sure you compiled gme in ${vlc_string_gme_tree}])
     fi
-  else
+  ], [
       AC_MSG_WARN([only static linking is available, you must provide a gme-tree])
-  fi
+  ])
   AC_LANG_POP(C++)
 ])
 
@@ -2547,24 +2502,20 @@ dnl  mad plugin
 dnl
 VLC_FEATURE_OPTION([mad], [libmad module])
 AS_IF([VLC_FEATURE_ENABLED([mad])], [
-  AC_ARG_WITH(mad,
-    [  --with-mad=PATH         path to libmad],[],[])
-  if test "${with_mad}" != "no" -a -n "${with_mad}"
-  then
-    VLC_ADD_CPPFLAGS([mpgatofixed32],[-I${with_mad}/include])
-    VLC_ADD_LIBS([mpgatofixed32],[-L${with_mad}/lib])
-  fi
+  VLC_STRING_OPTION([mad], [path to libmad], [PATH])
+  AS_IF([VLC_STRING_SET([mad])], [
+    VLC_ADD_CPPFLAGS([mpgatofixed32],[-I${vlc_string_mad}/include])
+    VLC_ADD_LIBS([mpgatofixed32],[-L${vlc_string_mad}/lib])
+  ])
 
-  AC_ARG_WITH(mad-tree,
-    [  --with-mad-tree=PATH    mad tree for static linking],[],[])
-  if test "${with_mad_tree}" != "no" -a -n "${with_mad_tree}"
-  then
-    real_mad_tree="`cd ${with_mad_tree} 2>/dev/null && pwd`"
+  VLC_STRING_OPTION([mad-tree], [mad tree for static linking], [PATH])
+  AS_IF([VLC_STRING_SET([mad-tree])], [
+    real_mad_tree="`cd ${vlc_string_mad_tree} 2>/dev/null && pwd`"
     if test -z "${real_mad_tree}"
     then
       dnl  The given directory can't be found
       AC_MSG_RESULT(no)
-      AC_MSG_ERROR([${with_mad_tree} directory doesn't exist])
+      AC_MSG_ERROR([${vlc_string_mad_tree} directory doesn't exist])
     fi
     dnl  Use a custom libmad
     AC_MSG_CHECKING(for mad.h in ${real_mad_tree})
@@ -2584,7 +2535,7 @@ AS_IF([VLC_FEATURE_ENABLED([mad])], [
       AC_MSG_RESULT(no)
       AC_MSG_ERROR([the specified tree doesn't have mad.h])
     fi
-  else
+  ], [
     CPPFLAGS="${CPPFLAGS_save} ${CPPFLAGS_mpgatofixed32}"
     LDFLAGS="${LDFLAGS_save} ${LIBS_mpgatofixed32}"
     AC_CHECK_HEADERS(mad.h, ,
@@ -2595,7 +2546,7 @@ AS_IF([VLC_FEATURE_ENABLED([mad])], [
       [ AC_MSG_ERROR([Cannot find libmad library...]) ])
     CPPFLAGS="${CPPFLAGS_save}"
     LDFLAGS="${LDFLAGS_save}"
-  fi
+  ])
 ])
 
 dnl
@@ -2787,17 +2738,15 @@ dnl  faad decoder plugin
 dnl
 VLC_FEATURE_OPTION([faad], [faad codec], [disabled])
 AS_IF([VLC_FEATURE_ENABLED([faad])], [
-  AC_ARG_WITH(faad-tree,
-  [  --with-faad-tree=PATH   faad tree for static linking])
-  if test -n "${with_faad_tree}"
-  then
-    AC_MSG_CHECKING(for libfaad.a in ${with_faad_tree})
-    real_faad_tree="`cd ${with_faad_tree} 2>/dev/null && pwd`"
+  VLC_STRING_OPTION([faad-tree], [faad tree for static linking], [PATH])
+  AS_IF([VLC_STRING_SET([faad-tree])], [
+    AC_MSG_CHECKING(for libfaad.a in ${vlc_string_faad_tree})
+    real_faad_tree="`cd ${vlc_string_faad_tree} 2>/dev/null && pwd`"
     if test -z "${real_faad_tree}"
     then
       dnl  The given directory can't be found
       AC_MSG_RESULT(no)
-      AC_MSG_ERROR([cannot cd to ${with_faad_tree}])
+      AC_MSG_ERROR([cannot cd to ${vlc_string_faad_tree}])
     fi
     if test -f "${real_faad_tree}/libfaad/.libs/libfaad.a"
     then
@@ -2809,9 +2758,9 @@ AS_IF([VLC_FEATURE_ENABLED([faad])], [
     else
       dnl  The given libfaad wasn't built
       AC_MSG_RESULT(no)
-      AC_MSG_ERROR([cannot find ${real_faad_tree}/libfaad/.libs/libfaad.a, make sure you compiled libfaad in ${with_faad_tree}])
+      AC_MSG_ERROR([cannot find ${real_faad_tree}/libfaad/.libs/libfaad.a, make sure you compiled libfaad in ${vlc_string_faad_tree}])
     fi
-  else
+  ], [
     CPPFLAGS="${CPPFLAGS_save} ${CPPFLAGS_faad}"
     LDFLAGS="${LDFLAGS_save} ${LIBS_faad}"
     AC_CHECK_HEADERS(faad.h, ,
@@ -2825,7 +2774,7 @@ AS_IF([VLC_FEATURE_ENABLED([faad])], [
         [ AC_MSG_ERROR([Cannot find libfaad library...]) ]))
     LDFLAGS="${LDFLAGS_save}"
     CPPFLAGS="${CPPFLAGS_save}"
-  fi
+  ])
 ])
 
 dnl
@@ -2886,18 +2835,15 @@ dnl A52/AC3 decoder plugin
 dnl
 VLC_FEATURE_OPTION([a52], [A/52 support with liba52])
 AS_IF([VLC_FEATURE_ENABLED([a52])], [
-  AC_ARG_WITH(a52,
-    [  --with-a52=PATH         a52 headers and libraries])
-  AC_ARG_WITH(a52-tree,
-    [  --with-a52-tree=PATH    a52dec tree for static linking ],[],[])
-  if test "${with_a52_tree}" != "no" -a -n "${with_a52_tree}"
-  then
-    real_a52_tree="`cd ${with_a52_tree} 2>/dev/null && pwd`"
+  VLC_STRING_OPTION([a52], [a52 headers and libraries], [PATH])
+  VLC_STRING_OPTION([a52-tree], [a52 tree for static linking], [PATH])
+  AS_IF([VLC_STRING_SET([a52-tree])], [
+    real_a52_tree="`cd ${vlc_string_a52_tree} 2>/dev/null && pwd`"
     if test -z "${real_a52_tree}"
     then
       dnl  The given directory can't be found
       AC_MSG_RESULT(no)
-      AC_MSG_ERROR([${with_a52_tree} directory doesn't exist])
+      AC_MSG_ERROR([${vlc_string_a52_tree} directory doesn't exist])
     fi
     dnl  Use a custom a52dec
     AC_MSG_CHECKING(for a52.h in ${real_a52_tree}/include)
@@ -2924,15 +2870,11 @@ AS_IF([VLC_FEATURE_ENABLED([a52])], [
       AC_MSG_RESULT(no)
       AC_MSG_ERROR([the specified tree doesn't have a52.h])
     fi
-  else
-    if test -z "${with_a52}"
-    then
-      LDFLAGS_test=""
-      CPPFLAGS_test=""
-    else
-      LDFLAGS_test="-L${with_a52}/lib"
-      CPPFLAGS_test="-I${with_a52}/include"
-    fi
+  ], [
+    AS_IF([VLC_STRING_SET([a52])], [
+      LDFLAGS_test="-L${vlc_string_a52}/lib"
+      CPPFLAGS_test="-I${vlc_string_a52}/include"
+    ])
     CPPFLAGS="${CPPFLAGS_save} ${CPPFLAGS_test} ${CPPFLAGS_a52tofloat32}"
     LDFLAGS="${LDFLAGS_save} ${LDFLAGS_test} ${LIBS_a52tofloat32}"
     AC_CHECK_HEADERS(a52dec/a52.h, [
@@ -2948,12 +2890,11 @@ AS_IF([VLC_FEATURE_ENABLED([a52])], [
     ])
     CPPFLAGS="${CPPFLAGS_save}"
     LDFLAGS="${LDFLAGS_save}"
-  fi
+  ])
 ])
 
-AC_ARG_WITH(a52-fixed,
-      [  --with-a52-fixed        specify if liba52 has been compiled with fixed point support],
-      [
+VLC_FEATURE_OPTION([a52-fixed], [specify if liba52 has been compiled with fixed point support], [disabled])
+AS_IF([VLC_FEATURE_ENABLED([a52-fixed])], [
         VLC_ADD_CPPFLAGS([a52tofloat32],[-DLIBA52_FIXED]) ])
 
 dnl
